//+------------------------------------------------------------------+
//|                                              Template Custom.mq4 |
//|                                                                  |
//|                                                                  |
//+------------------------------------------------------------------+
#property copyright ""
#property link      ""
#property show_inputs

//---- input
extern int TakeProfit = 200; 
extern int Stop = 80; 
extern int Trailing = 40; 
extern int PlusSafetyPercent = 10;
extern int magicNumber = 5;
extern int slip = 5;
 
//---- var
int in[7] ;
double do[6];

//+------------------------------------------------------------------+

int init()
  {
   clear();
   Print("Starting Lots = ",Lots()*MarketInfo(Symbol(),23));
   if ( in[6] < Trailing ) 
    Print("Trailing Stop is smaller than allowed, should be minimum = ",in[6]);
   return(0);
  }

//+------------------------------------------------------------------+

int start()
  {
  
// new period selection

   in[1] = Time[0];
   do[1] = Close[0]; 
   if ( in[0] < in[1] ) clear(); // update new bar time
     
// order selection
   
//   if ( in[2] > 0 && in[3] > 0 ) return(0) ; // buy and sell done in the current bar = exit
   in[4] = -1;
   if ( do[0] < do[1] // buy condition
        && in[2] < 1 ) // no opened buy possition on the current bar
    in[4] = 0 ; // order selection is OP_SELL
   else
   if ( do[0] > do[1] // sell condition
        && in[3] < 1 ) // no opened sell possition on the current bar
    in[4] = 1 ; // order selection is OP_SELL
   
// orders part
   
//   if (in[4] < 0 ) return(0); // no signal = exit
   if ( in[4] == 0 ) // buy condition met = send new buy order
       in[2] = OrderSend ( Symbol() , in[4] , Lots() * do[2] , Ask , slip , 
         Ask - Stop * Point , Bid + TakeProfit * Point , "" , magicNumber , 0 , Green ) ;

   if ( in[4] == 1 ) // sell condition met =  = send new order
       in[3] = OrderSend ( Symbol() , in[4] , Lots() * do[2] , Bid , slip , 
         Bid + Stop * Point , Ask - TakeProfit * Point , "" , magicNumber , 0 , Green ) ;

// check for trailing stop

  if ( Trailing > in[6] ) trail(); // if trailing is bigger than minimum stop level do trailing

   return(0);
  } 
  
//+------------------------------------------------------------------+

double Lots()
  {
// volume lots section
   double lot;
   do[3] = MarketInfo(Symbol(),32);
   in[5] = AccountFreeMargin();
   do[5] = in[5]/do[3]/do[2];
   lot = NormalizeDouble(MathMin(MathMax(in[5]/do[3]*in[5]/
     (( TakeProfit + Stop )*0.01*(1+PlusSafetyPercent)
     *(in[5]/do[3])*do[4]+in[5]),
     do[2]),MarketInfo(Symbol(),25))/do[2],0);
   return(lot);
  }
  
//+------------------------------------------------------------------+

void clear()
  {
// new period selection clear
   do[2] = MarketInfo(Symbol(),23);
   do[4] = MarketInfo(Symbol(),16);
   in[6] = MarketInfo(Symbol(),14);
   do[0] = do[1] ;
   in[0] = in[1] ;
   in[2] = 0 ;
   in[3] = 0 ;
   return;
  }
  
//+------------------------------------------------------------------+

void trail()
  {

   int total = OrdersTotal();
   
   for(int cnt=0;cnt<total;cnt++)
     {
      OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES);
      if(OrderType()==OP_BUY && OrderSymbol()==Symbol() && OrderMagicNumber() == magicNumber)
        {
// buy possitions
               if(Bid-OrderOpenPrice()>Point*Trailing)
                 {
                  if(OrderStopLoss()<Bid-Point*Trailing)
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Bid-Point*Trailing,OrderTakeProfit(),0,Green);
                     return(0);
                    }
                 }
              }
         else
      if(OrderType()==OP_SELL && OrderSymbol()==Symbol() && OrderMagicNumber() == magicNumber)
           {
// sell possitions
               if((OrderOpenPrice()-Ask)>(Point*Trailing))
                 {
                  if((OrderStopLoss()>(Ask+Point*Trailing)) || (OrderStopLoss()==0))
                    {
                     OrderModify(OrderTicket(),OrderOpenPrice(),Ask+Point*Trailing,OrderTakeProfit(),0,Red);
                     return(0);
                    }
                 }
              }
           }
         return;
        }

